function [points,second]=cut(z1,z2)
% POINT=CUT(LINE,LINE)
% POINTS=CUT(LINE,CIRCLE)
% POINTS=CUT(CIRCLE,LINE)
% POINTS=CUT(CIRCLE,CIRCLE)
type1=size(z1); type2=size(z2);
line=[2 1]; circle=[1 2];
if all(type1==line) & all(type2==line),
  lhs=diff([z1 z2]); rhs=z1(1)-z2(1);
  if abs(imag(lhs(1)*conj(lhs(2))))<eps*norm(lhs), points=NaN; return;
  end
  cd=[real(lhs); imag(lhs)]\[real(rhs); imag(rhs)];
  points=z1(1)-cd(1)*lhs(1);
  return
elseif all(type1==circle) & all(type2==circle),  
  z2=axis(z1,z2); type2=line;
elseif all(type1==line) & all(type2==circle),
  z=z1; z1=z2; z2=z;  type1=size(z1); type2=size(z2);
end
if ~(all(type2==line) & all(type1==circle)),
  points='INTERSECT: invalid arguments', return
end
c=z1(1); r=z1(2); p=nearest(z2,c); R=p-c; 
f=abs(R/r);
if abs(1-f)<64*eps, points=p; return; end
if f>1, points=[]; return; end
points=p+[-i;i]*sqrt(1/(f*f)-1)*R;
if nargout==2, second=points(2); points=points(1); end
 
