function W=invert(A,C)
% INVERT(A,C) inverts A in the circle C

big=1e8;
if nargin<2, C=[0,1]; end
[m,n]=size(A); R2=C(2)*conj(C(2)); R=sqrt(R2);

if m~=2 & n~=2,                      % If A is a point set, 
  W=conj(R2./(A-C(1)))+C(1); return  % transform it and quit
  end

if m==2,       % If A is a line,
  M=sum(A)/2;  % M is the midpoint of A 
  for k=1:2,                          % If either endpoint of A equals C(1), 
    if abs(C(1)-A(k))*big<R, A(k)=M; end    % replace it by M 
  end
  a=area([A;C(1)]); 
  if sqrt(abs(a))*big<R,                    % If A passes through C(1), 
    W=conj( R2 ./ (A-C(1))) + C(1); return  % transform and quit
  end
  W=circumcircle(conj(R2./([A;M]-C(1)))+C(1)); 
  return
end      

% A must be a circle.

r=A(2);
 
if abs(C(1)-A(1))*big<R,     % If A and C are concentric, 
  W=[C(1), -R2/r]; return    % transform A and quit
  end

if abs(abs(C(1)-A(1))-abs(r))*big<R,  % If A passes through C(1), 
  W=axis(A,C);                % W is radical axis of A and C
  if area([W;A(1)])*r>0,      % If triangle [W;A(1)] has same sense as A,  
     W=W([2;1]);              %   reverse direction of line 
  end
  return
end

A=A(1)+r*[1;-1]*sign(A(1)-C(1));  % diameter of A along line through centres
A=conj(R2./(A-C(1)))+C(1);         % invert it
W=[sum(A)/2,-sign(r)*abs(diff(A))/2];

