function parallel(L1,L2,mark)
% PARALLEL(L1,L2) marks lines L1 and L2 as parallel if they are so,
%  otherwise does nothing.  If they are parallel but L2 runs opposite
%  to L1, the arrows point in the direction of L1.
% PARALLEL(L1,L2,'<<'), PARALLEL(L1,L2,'<<<') etc. uses more than one
%  arrowhead
% PARALLEL(L1,L2,'!'), PARALLEL(L1,L2,'!<<') etc. marks lines L1 and L2
%  even if not actually parallel.  If present, '!' must be the first symbol.
D1=diff(L1); D2=diff(L2); T=D1*conj(D2);
tol=1e-4;
if nargin<3, mark=''; end
if mark(1)=='!', tol=inf; mark(1)=''; end
if length(mark)==0, mark='<'; end
if abs(imag(T))<=tol*abs(T),
  if real(T)<0, L2=L2([2 1]); end
  markline(L1,mark); markline(L2,mark);
  end

